#ifndef __CHM_CHAMELEON_ENCODING_H__
#define __CHM_CHAMELEON_ENCODING_H__
//--------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved.
//
// Class: CHMchameleonEncoding
//
// Description:
//
// Class interface definition.
//
// This file is automatically generated.
// DO NOT EDIT.
//
// Author: codegen2
// Date:   Tuesday, August 11th, 2009 @ 05:32:24 PM
// Revision: $Revision: 1.3 $
//
// Last Edit Date: $Date: 2009-08-11 21:35:20 $
// Source: $Source: /home/cvs/cvsroot/CHM/CHMchameleonEncoding.h,v $
//--------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>

#ifndef __CHM_CHAMELEON_ENCODING_HANDLE_H__
#define __CHM_CHAMELEON_ENCODING_HANDLE_H__
typedef void* CHMchameleonEncodingHandle;
#endif


/**
 * This class contains functions to change the current encoding used internally by 
 * Chameleon at runtime. Changes made here affect all currently instantiated 
 * Engines and Chameleon network connections.
 * 
 *  The locale set here is used to determine how to 
 * 
 *  1) Translate .NET and Java unicode strings to and from the internal 
 * representation used in Chameleon for both Engine and network operations. See 
 * http://www.interfaceware.com/manual/setting_encoding.html for more details.
 * 
 *  2) Determine how strings are parsed with an Engine.
 * 
 */
class CHMchameleonEncoding
{
public:
   /** Constructor */
   CHMchameleonEncoding();
   CHMchameleonEncoding(const CHMchameleonEncoding& Orig);
   CHMchameleonEncoding(CHMchameleonEncodingHandle Handle);
   
   /** Destructor */
   virtual ~CHMchameleonEncoding();
   
   /** Assignment operator */
   CHMchameleonEncoding& operator=(const CHMchameleonEncoding& Orig);
   
   /** This method is part of the internal implementation of this class and should not be called. */
   CHMchameleonEncodingHandle GetHandle() const { return Handle; }
   
   
   /**
    * Get the translation locale.
    * 
    * The initial value is extracted from the default system locale.
    * 
    */
   static const char* GetCurrentTranslationLocale();
   
   
   /**
    * Set the translation locale. See 
    * http://www.interfaceware.com/manual/setting_encoding.html for more details 
    * 
    * @param NewLocale New Locale Setting
    */
   static void SetCurrentTranslationLocale(const char* NewLocale);
   
   
   /**
    * Get the total number of supported translation locales. 
    * 
    */
   static CHMint32 CountOfTranslationLocale();
   
   
   /**
    * Get a translation locale at a particular index.
    * 
    * @param LocaleIndex Locale Index
    */
   static const char* TranslationLocale(CHMint32 LocaleIndex);
   
   
private:
   CHMchameleonEncodingHandle Handle;
};

#endif // end of defensive include
