#ifndef __CHM_CONFIG_DLL_H__
#define __CHM_CONFIG_DLL_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2005 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMconfigDll
//
// Description:
//
//
// Author: Eliot Muir
// Revision: $Revision: 1.9 $
//
// Last Edit Date: $Date: 2006-10-19 23:19:35 $
// Source: $Source: /home/cvs/cvsroot/CHM/CHMconfigDll.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>
// CHM_DLL_FUNC(CHMresult) code equals zero for success

CHM_DLL_FUNC(CHMconfigDump)
(
   CHMconfigHandle  Handle,
   CHMchar**        ppDumpString
);

CHM_DLL_FUNC(CHMconfigGetOutputTrailingSeparators)
(
   CHMconfigHandle Handle,
   size_t*         pOutputTrailingSeparators
);

CHM_DLL_FUNC(CHMconfigSetOutputTrailingSeparators)
(
   CHMconfigHandle Handle,
   size_t          OutputTrailingSeparators
);

CHM_DLL_FUNC(CHMconfigSetEscapeChar)
(
   CHMconfigHandle Handle,
   CHMchar         EscapeChar
);

CHM_DLL_FUNC(CHMconfigGetEscapeChar)
(
   CHMconfigHandle Handle,
   CHMchar*          pEscapeChar
);

CHM_DLL_FUNC(CHMconfigGetCountOfLevel)
(
   CHMconfigHandle Handle,
   size_t*         pCountOfLevel
);

CHM_DLL_FUNC(CHMconfigGetSepChar)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   CHMchar*          pSepChar
);

CHM_DLL_FUNC(CHMconfigSetSepChar)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   CHMchar         SepChar
);

CHM_DLL_FUNC(CHMconfigGetRepeatChar)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t*          pRepeatChar
);

CHM_DLL_FUNC(CHMconfigSetRepeatChar)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t           RepeatChar
);

CHM_DLL_FUNC(CHMconfigGetEscapedRepeatChar)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t*        pEscapedChar
);

CHM_DLL_FUNC(CHMconfigSetEscapedRepeatChar)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t           EscapedChar
);

CHM_DLL_FUNC(CHMconfigGetSepEscapedChar)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t*          pEscapedChar
);

CHM_DLL_FUNC(CHMconfigSetSepEscapedChar)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t           EscapedChar
);

CHM_DLL_FUNC(CHMconfigGetSepCharPosition)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t*         pPosition
);

CHM_DLL_FUNC(CHMconfigSetSepCharPosition)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t          Position
);

CHM_DLL_FUNC(CHMconfigGetRepeatCharPosition)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t*         pPosition
);

CHM_DLL_FUNC(CHMconfigSetRepeatCharPosition)
(
   CHMconfigHandle Handle,
   size_t          CharIndex,
   size_t          Position
);

CHM_DLL_FUNC(CHMconfigGetEscapeCharEscaped)
(
   CHMconfigHandle Handle,
   size_t*          pChar
);

CHM_DLL_FUNC(CHMconfigSetEscapeCharEscaped)
(
   CHMconfigHandle Handle,
   size_t           Char
);

CHM_DLL_FUNC(CHMconfigGetEscapeCharPosition)
(
   CHMconfigHandle Handle,
   size_t*           pPosition
);

CHM_DLL_FUNC(CHMconfigSetEscapeCharPosition)
(
   CHMconfigHandle Handle,
   size_t            Position
);

CHM_DLL_FUNC(CHMconfigGetHeaderSegment)
(
   CHMconfigHandle Handle,
   const CHMchar**       ppHeaderSegment
);

CHM_DLL_FUNC(CHMconfigSetHeaderSegment)
(
   CHMconfigHandle Handle,
   const CHMchar*        pHeaderSegment
);

CHM_DLL_FUNC(CHMconfigGetStubFileDir)
(
   CHMconfigHandle Handle,
   const CHMchar**       ppStubFileDir
);

CHM_DLL_FUNC(CHMconfigSetStubFileDir)
(
   CHMconfigHandle Handle,
   const CHMchar*        pStubFileDir
);

CHM_DLL_FUNC(CHMconfigGetStubFileLanguage)
(
   CHMconfigHandle Handle,
   const CHMchar**       ppStubFileLanguage
);

CHM_DLL_FUNC(CHMconfigGetDefaultHeader)
(
   CHMconfigHandle Handle,
   const CHMchar**       ppDefaultHeader
);

CHM_DLL_FUNC(CHMconfigGetParseSeparatorChars)
(
   CHMconfigHandle Handle,
   size_t*         pParseSeparatorChars
);

CHM_DLL_FUNC(CHMconfigSetParseSeparatorChars)
(
   CHMconfigHandle Handle,
   size_t          ParseSeparatorChars
);

CHM_DLL_FUNC(CHMconfigAddSepCharAt)
(
   CHMconfigHandle Handle,
   size_t          Index
);

CHM_DLL_FUNC(CHMconfigRemoveSepChar)
(
   CHMconfigHandle Handle,
   size_t          Index
);

CHM_DLL_FUNC(CHMconfigGetLowestNonEscapedChar)
(
   CHMconfigHandle Handle,
   unsigned short*          pChar          
);

CHM_DLL_FUNC(CHMconfigSetLowestNonEscapedChar)
(
   CHMconfigHandle Handle,
   unsigned short           Char          
);

CHM_DLL_FUNC(CHMconfigGetHighestNonEscapedChar)
(
   CHMconfigHandle Handle,
   unsigned short*          pChar          
);

CHM_DLL_FUNC(CHMconfigSetHighestNonEscapedChar)
(
   CHMconfigHandle Handle,
   unsigned short           Char          
);

CHM_DLL_FUNC(CHMconfigGetPresetConfig)
(
   CHMconfigHandle Handle,
   const CHMchar**       ppName
);

CHM_DLL_FUNC(CHMconfigSetPresetConfig)
(
   CHMconfigHandle Handle,
   const CHMchar*        pName
);


CHM_DLL_FUNC(CHMconfigSetPresetConfig)
(
   CHMconfigHandle Handle,
   const CHMchar*        pName
);

CHM_DLL_FUNC(CHMconfigSetDatabaseLabel)
(
   CHMconfigHandle Handle,
   size_t DatabaseLabel,
   const CHMchar* pLabel
);

CHM_DLL_FUNC(CHMconfigSetDatabaseAPI)
(
   CHMconfigHandle Handle,
   size_t DatabaseIndex,
   const CHMchar* pAPI
);

CHM_DLL_FUNC(CHMconfigSetDatabaseName)
(
   CHMconfigHandle Handle,
   size_t DatabaseIndex,
   const CHMchar* pName
);

CHM_DLL_FUNC(CHMconfigSetDatabaseUserName)
(
   CHMconfigHandle Handle,
   size_t DatabaseIndex,
   const CHMchar* pName
);

CHM_DLL_FUNC(CHMconfigSetDatabasePassword)
(
   CHMconfigHandle Handle,
   size_t DatabaseIndex,
   const CHMchar* pPassword
);

CHM_DLL_FUNC(CHMconfigGetDatabaseAPI)
(
   CHMconfigHandle Handle,
   size_t          DatabaseIndex,
   const char**    ppDatabaseAPI
);

CHM_DLL_FUNC(CHMconfigGetDatabaseLabel)
(
   CHMconfigHandle Handle,
   size_t          DatabaseIndex,
   const char**    ppDatabaseLabel
);

CHM_DLL_FUNC(CHMconfigGetDatabaseName)
(
   CHMconfigHandle Handle,
   size_t          DatabaseIndex,
   const char**    ppDatabaseName
);

CHM_DLL_FUNC(CHMconfigGetDatabaseUserName)
(
   CHMconfigHandle Handle,
   size_t          DatabaseIndex,
   const char**    ppDatabaseUserName
);

CHM_DLL_FUNC(CHMconfigGetDatabasePassword)
(
   CHMconfigHandle Handle,
   size_t          DatabaseIndex,
   const char**    ppDatabasePassword
);

CHM_DLL_FUNC(CHMconfigGetDatabaseCount)
(
   CHMconfigHandle Handle,
   size_t*         pCount
);

CHM_DLL_FUNC(CHMconfigGetDefaultDatabaseIndex)
(
   CHMconfigHandle Handle,
   size_t*         pIndex
);

CHM_DLL_FUNC(CHMconfigSetDefaultDatabaseIndex)
(
   CHMconfigHandle Handle,
   size_t          Index
);

CHM_DLL_FUNC(CHMconfigGetDatabaseIndex)
(
   CHMconfigHandle Handle,
   const CHMchar*  pLabel,
   size_t*         pIndex
);

CHM_DLL_FUNC(CHMconfigAddDatabase)
(
   CHMconfigHandle Handle,
   size_t*         pIndex
);

CHM_DLL_FUNC(CHMconfigRemoveDatabase)
(
   CHMconfigHandle Handle,
   size_t         Index
);

CHM_DLL_FUNC(CHMconfigGetIsDatabaseFunctionOn)
(
   CHMconfigHandle Handle,
   size_t*         pFlag
);

CHM_DLL_FUNC(CHMconfigSetIsDatabaseFunctionOn)
(
   CHMconfigHandle Handle,
   size_t          Flag
);

CHM_DLL_FUNC(CHMconfigGetDisablePythonNone)
(
   CHMconfigHandle Handle,
   size_t*         pFlag
);

CHM_DLL_FUNC(CHMconfigSetDisablePythonNone)
(
   CHMconfigHandle Handle,
   size_t          Flag
);

CHM_DLL_FUNC(CHMconfigCountOfDatabaseApi)
(
   CHMconfigHandle Handle,
   int* pCount
);

CHM_DLL_FUNC(CHMconfigGetDatabaseApiName)
(
   CHMconfigHandle Handle,
   int Index,
   const CHMchar** ppDatabaseApiName
);

#endif // end of defensive include
