#ifndef __CHM_DATA_TYPE__
#define __CHM_DATA_TYPE__
//---------------------------------------------------------------------------
// Module: CHMdataType
//
// Description:
//
// Enumeration of basic data types used throughout HL7 Chameleon
//
// Author: Eliot Muir
//---------------------------------------------------------------------------

#include <CHM/CHMdataTypeValue.h>
#include <CHM/CHMunicode.h>

typedef enum CHMdataType
{
   CHMstringType   = __CHM_STRING_TYPE,
   CHMintegerType  = __CHM_INTEGER_TYPE,
   CHMdoubleType   = __CHM_DOUBLE_TYPE,
   CHMcompositeType= __CHM_COMPOSITE_TYPE,
   CHMdateTimeType = __CHM_DATE_TIME_TYPE, 
   CHMenumerationType = __CHM_ENUMERATION_TYPE 
} CHMdataType;

const CHMchar* CHMoutputDataTypeAsString(const CHMdataType Type);
  
#define CHMint8 char
#define CHMint16 short
#define CHMint32 int
#ifdef CHM_UNIX
#   define CHMint64 long long 
#else
#   define CHMint64 __int64
#endif
#define CHMuint8 unsigned CHMint8
#define CHMuint16 unsigned CHMint16
#define CHMuint32 unsigned CHMint32
#define CHMuint64 unsigned CHMint64

#define CHMfloat32 float
#define CHMfloat64 double

#endif // end of defensive include
