//---------------------------------------------------------------------------
// Module: CHMdateTime
//
// Description:
//
// Thin interface wrapper class around HL7dateTime
//
//---------------------------------------------------------------------------

#ifndef __CHM_DATETIME__
#define __CHM_DATETIME__

#include <CHM/CHMminCInclude.h>
#include <time.h>

CHM_DLL_FUNC(CHMdateTimeCreate)
(
   CHMdateTimeHandle* Handle
);

CHM_DLL_FUNC(CHMdateTimeAddRef)
(
   CHMdateTimeHandle Handle
);

CHM_DLL_FUNC(CHMdateTimeRelease)
(
   CHMdateTimeHandle Handle
);

CHM_DLL_FUNC(CHMdateTimeGetDATE)
(
   CHMdateTimeHandle Handle,
   DATE*             pValue
);

CHM_DLL_FUNC(CHMdateTimeGetSecondFraction)
(
   CHMdateTimeHandle Handle,
   double*           pValue
);

CHM_DLL_FUNC(CHMdateTimeGetZone)
(
   CHMdateTimeHandle Handle,
   short*            pValue
);

CHM_DLL_FUNC(CHMdateTimeGetOffsetInMinutes)
(
   CHMdateTimeHandle Handle,
   short*            pValue
);

CHM_DLL_FUNC(CHMdateTimeGetOffsetIsDefined)
(
   CHMdateTimeHandle Handle,
   short*            pValue
);

CHM_DLL_FUNC(CHMdateTimeSetDATE)
(
   CHMdateTimeHandle Handle,
   DATE              NewValue
);

CHM_DLL_FUNC(CHMdateTimeSetSecondFraction)
(
   CHMdateTimeHandle Handle,
   double            NewValue
);

CHM_DLL_FUNC(CHMdateTimeSetZone)
(
   CHMdateTimeHandle Handle,
   short             NewValue
);

CHM_DLL_FUNC(CHMdateTimeSetOffsetInMinutes)
(
   CHMdateTimeHandle Handle,
   short             NewValue,
   short             IsDefined
);

CHM_DLL_FUNC(CHMdateTimeGetIsNull)
(
    CHMdateTimeHandle Handle,
    short*            pValue
);

CHM_DLL_FUNC(CHMdateTimeGetTimeT)
(
   CHMdateTimeHandle Handle,
   time_t*           pValue
);

CHM_DLL_FUNC(CHMdateTimeSetTimeT)
(
   CHMdateTimeHandle Handle,
   time_t            Value
);

CHM_DLL_FUNC(CHMdateTimeSetNow)
(
   CHMdateTimeHandle Handle
);

CHM_DLL_FUNC(CHMdateTimeFormat)
(
   CHMdateTimeHandle Handle,
   const CHMchar*    pFormat,
   const CHMchar**   ppOutput
);

CHM_DLL_FUNC(CHMdateTimeSetNull)
(
   CHMdateTimeHandle Handle
);

#endif // end of defensive include
