#ifndef __CHM_DLL_H__
#define __CHM_DLL_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2008 iNTERFACEWARE Inc. All Rights Reserved
//
// Module: CHMdll
//
// Description:
//
// Class which wraps basic shared library and dll functionality in an
// operating system independent manner.
//
// Author: Steven Dodd
// Date:   Jan 19, 2009
// Revision: $Revision: 1.1 $
//
// Last Edit Date: $Date: 2009-01-21 15:08:14 $
// Source: $Source: /home/cvs/cvsroot/CHM/CHMdll.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminCInclude.h>

CHM_DLL_FUNC(CHMdllCreate)
(
   CHMdllHandle* HandleOut
);

CHM_DLL_FUNC(CHMdllAddRef)
(
   CHMdllHandle Handle
);

CHM_DLL_FUNC(CHMdllRelease)
(
   CHMdllHandle Handle
);

CHM_DLL_FUNC(CHMdllLoadLibrary)
(
   CHMdllHandle Handle,
   const CHMchar * LibraryPath,
   CHMboolean TakeOwnership
);

CHM_DLL_FUNC(CHMdllFreeLibrary)
(
   CHMdllHandle Handle
);

CHM_DLL_FUNC(CHMdllGetProcAddress)
(
   CHMdllHandle Handle,
   const CHMchar * ProcName,
   void** ProcAddressOut
);

CHM_DLL_FUNC(CHMdllGetLibraryName)
(
   CHMdllHandle Handle,
   const CHMchar ** LibraryNameOut
);

#endif // end of defensive include
