#ifndef __CHM_DLL_CLASS_H__
#define __CHM_DLL_CLASS_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2008 iNTERFACEWARE Inc. All Rights Reserved
//
// Module: CHMdllClass
//
// Description:
//
// Class which wraps basic shared library and dll functionality in an
// operating system independent manner.
//
// Author: Steven Dodd
// Date:   Jan 19, 2009
// Revision: $Revision: 1.1 $
//
// Last Edit Date: $Date: 2009-01-21 15:08:14 $
// Source: $Source: /home/cvs/cvsroot/CHM/CHMdllClass.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>
#include <CHM/CHMstring.h>

class CHMdll
{
public:
   CHMdll();
   virtual ~CHMdll();   

   void loadLibrary(const CHMstring& DllFileName, CHMboolean IsOwner=true);
   
   void freeLibrary();
   
   void* getProcAddress(const char* ProcName);

   CHMstring libraryName() const;

private:
   CHMdllHandle DllHandle;
   CHMdll& operator=(const CHMdll& Orig); // not allowed 
   CHMdll(const CHMdll& Orig); // not allowed
};

#endif // end of defensive include
