#ifndef __CHM_EDIT_OUTPUT_LOG__
#define __CHM_EDIT_OUTPUT_LOG__
//------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMeditOutputLog
//
// Author: Greg Norman
// Revision: $Revision: 1.6 $
//
// Last Edit Date: $Date: 2006-12-21 22:24:23 $
// Source: $Source: /home/cvs/cvsroot/CHM/CHMeditOutputLog.h,v $
//---------------------------------------------------------------------------
#include <CHM/CHMoutputLog.h>

class CEdit;
/** Outputs log to a windows CEdit control. 
 * This implementation of CHMoutputLog was used to construct a MFC
 * example HL7 interface in older versions of Chameleon.  This class will truncate the output when
 * it is larger than 16000 characters.
 **/
class CHMeditOutputLog 
: public CHMoutputLog
{
public:
   /** Construct a CHMeditOutputLog from a CEdit object.
    * This class <b>does not</b> take ownership of the CEdit object.
    */
   CHMeditOutputLog(CEdit* Edit) : pEdit(Edit) {}
   /** Destructor */
   virtual ~CHMeditOutputLog() {}
   
   /** Output \c pLine to the CEdit control. 
    *  The output will be truncated to 16000 characters.
    */
   virtual void OutputLine(const CHMchar* pLine);
private:
   CEdit* pEdit;
};
#endif // end of defensive include

