//---------------------------------------------------------------------------
// Module: CHMerror
//
// Description:
//
// Calls to access error information
//
//---------------------------------------------------------------------------

#ifndef __CHM_ERROR__
#define __CHM_ERROR__

#include <CHM/CHMminCInclude.h>

CHM_DLL_FUNC(CHMreferenceAddRef)
(
   CHMreferenceHandle Handle
);

CHM_DLL_FUNC(CHMreferenceRelease)
(
   CHMreferenceHandle Handle
);

CHM_DLL_FUNC(CHMerrorRelease)
(
   CHMresult Handle
);

CHM_DLL_FUNC(CHMerrorCreate)
(
   CHMreferenceHandle* pHandle,
   const char* pDescription
);

CHM_DLL_FUNC(CHMerrorGetDescription)
(
   CHMresult     Handle,
   const char**  Description
);

CHM_DLL_FUNC(CHMerrorGetDescriptionW)
(
   CHMresult       Handle,
   const wchar_t** Description
);

CHM_DLL_FUNC(CHMerrorGetCode)
(
   CHMresult      Handle,
   unsigned long* Code
);

CHM_DLL_FUNC(CHMerrorGetParameter)
(
   CHMresult Handle, 
   const CHMchar* pKey,
   const CHMchar** ppValue
);

CHM_DLL_FUNC(CHMerrorHasParameter)
(
   CHMresult Handle,
   const CHMchar* pKey,
   CHMboolean* pResult
);

CHM_DLL_FUNC(CHMerrorGetCountOfParameter)
(
   CHMresult Handle, 
   size_t* pValue
);

CHM_DLL_FUNC(CHMerrorGetKey)
(
   CHMresult Handle, 
   size_t KeyIndex,
   const CHMchar** ppValue
);

#endif // end of defensive include
