#ifndef _CHM_GLOBAL_DEFINES_H_
#define _CHM_GLOBAL_DEFINES_H_

// The purpose of this file is to allow various settings for
// the compilation of the Chameleon libraries to be applied globally.
 
// Define the macro CHM_USE_STL if your code uses the Standard Template
// library or Standard C++ library as it is sometimes called.
// This ensures that the old style iostream libraries are not included
// in the same project.  i.e. with CHM_USE_STL included the following
// settings are applied:
// #include <strstream>
// #include <iostream>
// #include <fstream>
// using namespace std;
// instead of 
// #include <strstream.h>
// #include <fstream.h>
// #include <strstream.h>
// #define CHM_USE_STL

#ifdef __BCPLUSPLUS__
#   define CHM_USE_STL
#endif

#if _MSC_VER == 1310
#   define CHM_USE_STL
#endif

#ifdef CHM_USE_STL
#   pragma message("Using Standard C++ Template Library.")
#   pragma message("See the file CHMglobalDefines.h in the CHM directory for")
#   pragma message("more information.")
#else
#   pragma message("Not using Standard C++ Template Library.")
#   pragma message("See the file CHMglobalDefines.h in the CHM directory for")
#   pragma message("more information.")
#endif // CHM_USE_STL


#endif // end of defensive include
