#ifndef __CHM_MESSAGE_DEDFINITION__
#define __CHM_MESSAGE_DEDFINITION__

//---------------------------------------------------------------------------
// Module: CHMmessage
//
// Description:
//
// This is a thin interface class to the real underlying HL7message class
// This approach is taken to hide the implementation of the HL7 Chameleon
// library from the client application - thus enabling easy upgrading without
// recompilation or relinking.
//
//---------------------------------------------------------------------------

#include <CHM/CHMminCInclude.h>

CHM_DLL_FUNC(CHMmessageCreate)
(
   CHMmessageHandle* Handle
);

CHM_DLL_FUNC(CHMmessageAddRef)
(
   CHMmessageHandle Handle
);

CHM_DLL_FUNC(CHMmessageRelease)
(
   CHMmessageHandle Handle
);

CHM_DLL_FUNC(CHMmessageGetName)
(
   CHMmessageHandle Handle,
   const CHMchar**  ppName
);

CHM_DLL_FUNC(CHMmessageGetDescription)
(
   CHMmessageHandle Handle,
   const CHMchar**  ppDescription
);


CHM_DLL_FUNC(CHMmessageGetTableGrammar)
(
    CHMmessageHandle Handle,
    CHMtableGrammarHandle* pGrammarHandle
);

#endif // __CHM_MESSAGE_DEDFINITION__
