#ifndef __CHM_IOSTREAM_STD_H__
#define __CHM_IOSTREAM_STD_H__

/**
 * Legacy iostream output operators for CHM objects.
 * Include this file to use new standard iostreams.
 */

#include <iostream>
using namespace std;

#include <CHM/CHMdateTime.h>
#include <CHM/CHMengineClass.h>
#include <CHM/CHMerrorClass.h>
#include <CHM/CHMstring.h>
#include <CHM/CHMtableClass.h>

ostream& operator<<(ostream& Stream, const CHMstring& String)
{
   return Stream << String.c_str();
}

ostream& operator<<(ostream& Stream, const CHMdateTime& DateTime)
{
   return Stream << DateTime.Dump();
}

ostream& operator<<(ostream& Stream, const CHMengine& Engine)
{
   return Stream << Engine.Dump();
}

ostream& operator<<(ostream& Stream, const CHMerror& Error)
{
   return Stream << Error.Dump();
}

ostream& operator<<(ostream& Stream, const CHMtable& Table)
{
   return Stream << Table.Dump();
}

#endif
