//---------------------------------------------------------------------------
// Module: CHMparseError
//
// Description:
//
// Enumeration of parse errors
//---------------------------------------------------------------------------

// Common file with debug macros for use in application
#ifndef __CHM_PARSE_ERROR__
#define __CHM_PARSE_ERROR__
#include <CHM/CHMparseErrorEnum.h>

typedef 
enum CHMparseError
{
   CHMpeRequiredFieldNotPresent      = CHM_DEF_peRequiredFieldNotPresent, 
   CHMpeRequiredSubFieldNotPresent   = CHM_DEF_peRequiredSubFieldNotPresent, 
   CHMpeRequiredSubSubFieldNotPresent= CHM_DEF_peRequiredSubSubFieldNotPresent, 
   CHMpeFieldMaxRepeatsExceeded     = CHM_DEF_peFieldMaxRepeatsExceeded, 
   CHMpeUnexpectedExtraFields       = CHM_DEF_peUnexpectedExtraFields,  
   CHMpeFieldMaxLengthExceeded      = CHM_DEF_peFieldMaxLengthExceeded,  
   CHMpeUnexpectedSegment           = CHM_DEF_peUnexpectedSegment,       
   CHMpeRequiredSegmentMissing      = CHM_DEF_peRequiredSegmentMissing,  
   CHMpeRequiredSegmentGroupMissing = CHM_DEF_peRequiredSegmentGroupMissing, 
   CHMpeUnexpectedTrailingSegments  = CHM_DEF_peUnexpectedTrailingSegments, 
   CHMpeBadEscapeSequence           = CHM_DEF_peBadEscapeSequence,          
   CHMpeNoSegmentIdentifier         = CHM_DEF_peNoSegmentIdentifier,        
   CHMpeBadIntegerFormat            = CHM_DEF_peBadIntegerFormat,        
   CHMpeBadDoubleFormat             = CHM_DEF_peBadDoubleFormat,        
   CHMpeBadDateTimeFormat           = CHM_DEF_peBadDateTimeFormat,
   CHMpeBadEnumFormat               = CHM_DEF_peBadEnumFormat        
} CHMparseError;
#endif // end of defensive include
