#ifndef __CHM_TABLE_DEDFINITION__
#define __CHM_TABLE_DEDFINITION__

//---------------------------------------------------------------------------
// Module: CHMtable
//
// Description:
//
// This is a thin interface class to the real underlying HL7table class
// This approach is taken to hide the implementation of the HL7 Chameleon
// library from the client application - thus enabling easy upgrading without
// recompilation or relinking.
//
//---------------------------------------------------------------------------

#include <CHM/CHMminCInclude.h>
#include <CHM/CHMdataType.h>

CHM_DLL_FUNC(CHMtableDefinitionCreate)
(
   CHMtableDefinitionHandle* Handle
);

CHM_DLL_FUNC(CHMtableDefinitionAddRef)
(
   CHMtableDefinitionHandle Handle
);

CHM_DLL_FUNC(CHMtableDefinitionRelease)
(
   CHMtableDefinitionHandle Handle
);

CHM_DLL_FUNC(CHMtableDefinitionGetTableName)
(
   CHMtableDefinitionHandle  Handle,
   CHMchar**       pName
);

CHM_DLL_FUNC(CHMtableDefinitionGetCountOfColumn)
(
   CHMtableDefinitionHandle Handle,
   size_t*        Count
);

CHM_DLL_FUNC(CHMtableDefinitionGetColumnType)
(
   CHMtableDefinitionHandle Handle,
   size_t         ColumnIndex,
   CHMdataType*   pDataType
);

CHM_DLL_FUNC(CHMtableDefinitionGetColumnName)
(
   CHMtableDefinitionHandle Handle,
   size_t         ColumnIndex,
   CHMchar**      pColumnName
);

CHM_DLL_FUNC(CHMtableDefinitionGetColumnIsKey)
(
   CHMtableDefinitionHandle Handle,
   size_t ColumnIndex,
   size_t* pIsKey
);
#endif // end of defensive include
