#ifndef __CHM_TABLE_DEFINITION_CLASS_H__
#define __CHM_TABLE_DEFINITION_CLASS_H__

#include <CHM/CHMminimumInclude.h>
#include <CHM/CHMdataType.h>
class CHMtableDefinitionPrivate;

class CHMtableDefinition
{
public:
   CHMtableDefinition();
   explicit CHMtableDefinition(CHMtableDefinitionHandle Handle);
   virtual ~CHMtableDefinition();

   
   const char* TableName() const;

   CHMtableDefinitionHandle GetTableDefHandle() const;

  
   // These methods are used for accessing the columns
   // at runtime - ColumnIndex will return size_t(-1) for
   // a non-existent column name
   size_t CountOfColumn() const;
   const char* ColumnName(size_t ColumnIndex) const;
   CHMdataType ColumnType(size_t ColumnIndex) const;

   CHMboolean IsKey(size_t ColumnIndex) const;

   // This function is deprecated. Use Dump instead. See manual for migration guide.
   //
   // void printOn(IOostream& Stream) const;

   /** Output the table definitions's contents to a string
    * This is useful for diagnostics
    */
   CHMstring Dump() const;

private:
   CHMtableDefinitionPrivate* pMember;
   CHMtableDefinition(const CHMtableDefinition& Orig);             // not allowed
   CHMtableDefinition& operator=(const CHMtableDefinition& Orig);  // not allowed
};

// This function is deprecated. Use Dump instead. See manual for migration guide.
//
// IOostream& operator<<(IOostream& Stream, const CHMtableDefinition& TableDef);

#endif // __CHM_TABLE_DEFINITION_CLASS_H__
