#ifndef __CHM_TABLE_GRAMMAR__
#define __CHM_TABLE_GRAMMAR__

//---------------------------------------------------------------------------
// Module: CHMtable
//
// Description:
//
// This is a thin interface class to the real underlying HL7table class
// This approach is taken to hide the implementation of the HL7 Chameleon
// library from the client application - thus enabling easy upgrading without
// recompilation or relinking.
//
//---------------------------------------------------------------------------

#include <CHM/CHMminCInclude.h>
#include <CHM/CHMdataType.h>

CHM_DLL_FUNC(CHMtableGrammarCreate)
(
   CHMtableGrammarHandle* Handle
);

CHM_DLL_FUNC(CHMtableGrammarAddRef)
(
   CHMtableGrammarHandle Handle
);

CHM_DLL_FUNC(CHMtableGrammarRelease)
(
   CHMtableGrammarHandle Handle
);

CHM_DLL_FUNC(CHMtableGrammarGetName)
(
   CHMtableGrammarHandle  Handle,
   const CHMchar**       pName
);

CHM_DLL_FUNC(CHMtableGrammarGetCountOfSubGrammar)
(
   CHMtableGrammarHandle Handle,
   size_t*        Count
);

CHM_DLL_FUNC(CHMtableGrammarGetSubGrammar)
(
   CHMtableGrammarHandle Handle,
   size_t SubGrammarIndex,
   CHMtableGrammarHandle* pSubGrammarHandle
);

CHM_DLL_FUNC(CHMtableGrammarGetIsNode)
(
   CHMtableGrammarHandle Handle,
   size_t*               pFlag
);

CHM_DLL_FUNC(CHMtableGrammarGetTable)
(
   CHMtableGrammarHandle Handle,
   CHMtableHandle* pTableHandle
);

#endif // __CHM_TABLE_GRAMMAR__
