#ifndef __CHM_TABLE_GRAMMAR_CLASS_H__
#define __CHM_TABLE_GRAMMAR_CLASS_H__

#include <CHM/CHMminimumInclude.h>
#include <CHM/CHMdataType.h>

class CHMtableGrammarPrivate;

class CHMtableGrammar
{
public:
   CHMtableGrammar();
   explicit CHMtableGrammar(CHMtableGrammarHandle Handle);
   virtual ~CHMtableGrammar();

   CHMtableGrammarHandle GetTableGrammarHandle() const;  
   
//interface
public:   
   const CHMchar* TableGrammarName() const;
   size_t CountOfSubGrammar() const;
   bool IsNode() const;
   CHMtableGrammarHandle GetSubGrammar(size_t Index) const;  
   CHMtableDefinitionHandle GetTableDefHandle() const;

   // This function is deprecated. Use Dump instead. See manual for migration guide.
   //
   // void printOn(IOostream& Stream) const;

   /** Output the table grammar's contents to a string
    * This is useful for diagnostics
    */
   CHMstring Dump() const;

private:
   CHMtableGrammarPrivate* pMember;
   CHMtableGrammar(const CHMtableGrammar& Orig);             // not allowed
   CHMtableGrammar& operator=(const CHMtableGrammar& Orig);  // not allowed
};

// This function is deprecated. Use Dump instead. See manual for migration guide.
//
// IOostream& operator<<(IOostream& Stream, const CHMtableGrammar& TableDef);

#endif // __CHM_TABLE_GRAMMAR_CLASS_H__
