//---------------------------------------------------------------------------
// Module: CHMunicode
//
// Description:
//
// This file is used to define a set of macros to provide Unicode
// portability.
//
//---------------------------------------------------------------------------

#ifndef __CHM_UNICODE__
#define __CHM_UNICODE__

   #define CHMchar char
   #define CHM_TEXT(x) x

#if defined(WIN32) && defined(CHM_64)
   #define CHMengineLoadT CHMengineLoad 
   #define CHMengineParseMessage CHMengineParseMessageA
   #define CHMengineMessageNameT CHMengineMessageName
   #define CHMengineSetLogCallBackT CHMengineSetLogCallBack
   #define CHMengineTransformMessageT CHMengineTransformMessage
   #define CHMengineGenerateMessageT  CHMengineGenerateMessage
   #define CHMtableSetString CHMtableSetStringA
   #define CHMtableGetString CHMtableGetStringA
   #define CHMtableNameT CHMtableName
   #define CHMtableColumnIndexT CHMtableColumnIndex
   #define CHMtableColumnNameT CHMtableColumnName
   #define CHMtableDumpT CHMtableDump
   #define CHMtableFreeBufferT CHMtableFreeBuffer
   #define CHMerrorGetDescriptionT CHMerrorGetDescription
   #define CHMengineDumpT       CHMengineDump
   #define CHMengineFreeBufferT CHMengineFreeBuffer
#else
   #define _CHMengineLoadT _CHMengineLoad 
   #define _CHMengineParseMessage _CHMengineParseMessageA
   #define _CHMengineMessageNameT _CHMengineMessageName
   #define _CHMengineSetLogCallBackT _CHMengineSetLogCallBack
   #define _CHMengineTransformMessageT _CHMengineTransformMessage
   #define _CHMengineGenerateMessageT  _CHMengineGenerateMessage
   #define _CHMtableSetString _CHMtableSetStringA
   #define _CHMtableGetString _CHMtableGetStringA
   #define _CHMtableNameT _CHMtableName
   #define _CHMtableColumnIndexT _CHMtableColumnIndex
   #define _CHMtableColumnNameT _CHMtableColumnName
   #define _CHMtableDumpT _CHMtableDump
   #define _CHMtableFreeBufferT _CHMtableFreeBuffer
   #define _CHMerrorGetDescriptionT _CHMerrorGetDescription
   #define _CHMengineDumpT       _CHMengineDump
   #define _CHMengineFreeBufferT _CHMengineFreeBuffer
#endif

   #define CHMstrcpy strcpy
   #define CHMstrncpy  strncpy
   #define CHMstrnset _strnset
   #define CHMstrlen   strlen
   #define CHMstrcmp   strcmp
   #define CHMstrncmp  strncmp
   #define CHMstricmp _stricmp
   #define CHMstribrk _strpbrk
   #define CHMstrchr   strchr
   #define CHMstrspn   strspn
   #if defined(__BORLANDC__) || defined(CHM_UNIX)
      #define CHMstrdup strdup
      #define _strdup strdup
      #define CHMstrlwr strlwr
      #define CHMstrupr strupr
   #else
      #define CHMstrlwr  _strlwr
      #define CHMstrdup   _strdup
      #define CHMstrupr  _strupr
   #endif
   #define CHMstrstr   strstr
   #define CHMaccess   _access
   #define CHMfopen    fopen
   #define CHMatoi     atoi
   #define CHMstrtod   strtod
   #define CHMstrpbrk  strpbrk
   #define CHMfprintf  fprintf
   #define CHMsprintf  sprintf
   #define CHMprintf   printf 
   #define CHMstrtol   strtol
   #define CHMmain main

#define CHM_CHAR_SIZE sizeof(CHMchar)
#endif // end of defensive include
