#ifndef __DLL_UNTYPED_MESSAGE_TREE_H__
#define __DLL_UNTYPED_MESSAGE_TREE_H__

//---------------------------------------------------------------------------
// Module: DLLuntypedMessageTree
//
// Description:
//
// This is a thin interface class to the real underlying CHMuntypedMessageTree
// class.  
//
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>
#include <CHM/CHMdataType.h>

typedef void* CHMuntypedMessageTreeHandle;
typedef void* CHMconfigHandle;

CHM_DLL_FUNC(CHMuntypedMessageTreeCreate)
(
   CHMuntypedMessageTreeHandle* Handle
);

CHM_DLL_FUNC(CHMuntypedMessageTreeAddRef)
(
   CHMuntypedMessageTreeHandle Handle
);

CHM_DLL_FUNC(CHMuntypedMessageTreeRelease)
(
   CHMuntypedMessageTreeHandle Handle
);

CHM_DLL_FUNC(CHMuntypedMessageTreeIsNode)
(
   CHMuntypedMessageTreeHandle Handle,
   short*                      IsNode
);

CHM_DLL_FUNC(CHMuntypedMessageTreeSubNode)
(
   CHMuntypedMessageTreeHandle  Handle,
   unsigned long                SubNodeIndex,
   unsigned long                RepeatNodeIndex,
   CHMuntypedMessageTreeHandle* pSubNode
);

CHM_DLL_FUNC(CHMuntypedMessageTreeCountOfSubNode)
(
   CHMuntypedMessageTreeHandle Handle,
   unsigned long*              pCountOfSubNode
);

CHM_DLL_FUNC(CHMuntypedMessageTreeGetValue)
(
   CHMuntypedMessageTreeHandle Handle,
   const CHMchar**             ppValue
);

CHM_DLL_FUNC(CHMuntypedMessageTreeSetValue)
(
   CHMuntypedMessageTreeHandle Handle,
   const CHMchar*              pValue
);

CHM_DLL_FUNC(CHMuntypedMessageTreeGetLabel)
(
   CHMuntypedMessageTreeHandle Handle,
   const CHMchar**             ppLabel
);

CHM_DLL_FUNC(CHMuntypedMessageTreeSetLabel)
(
   CHMuntypedMessageTreeHandle Handle,
   const CHMchar*              pValue
);

CHM_DLL_FUNC(CHMuntypedMessageTreeIsNull)
(
   CHMuntypedMessageTreeHandle Handle,
   short*                        pIsNull
);

CHM_DLL_FUNC(CHMuntypedMessageTreeCountOfRepeat)
(
   CHMuntypedMessageTreeHandle Handle,
   unsigned long*             pCountOfRepeat
);

CHM_DLL_FUNC(CHMuntypedMessageTreeGetRepeatedNode)
(
   CHMuntypedMessageTreeHandle Handle,
   unsigned long               RepeatIndex,
   CHMuntypedMessageTreeHandle* pRepeatedNode
);

CHM_DLL_FUNC(CHMuntypedMessageTreeDump)
(
   CHMuntypedMessageTreeHandle Handle,
   char**                   pDumpBuffer
);

CHM_DLL_FUNC(CHMuntypedMessageTreeFreeBuffer)
(
   char* pBuffer
);


CHM_DLL_FUNC(CHMuntypedMessageTreeCountOfError)
(
   CHMuntypedMessageTreeHandle Handle,
   unsigned long*             pCountOfError
);

CHM_DLL_FUNC(CHMuntypedMessageTreeErrorDescription)
(
   CHMuntypedMessageTreeHandle Handle,
   long Index,
   CHMchar** pValue
); 

CHM_DLL_FUNC(CHMuntypedMessageTreeErrorCode)
(
   CHMuntypedMessageTreeHandle Handle,
   long  Index,
   long* pValue
); 

CHM_DLL_FUNC(CHMuntypedMessageTreeFlatwire)
(
   CHMuntypedMessageTreeHandle Handle,
   long            Level,
   CHMconfigHandle ConfigHandle,
   CHMchar*        pBuffer,
   unsigned long   SizeOfBuffer,
   unsigned long*  pCountAvailable
);

CHM_DLL_FUNC(CHMuntypedMessageTreeClearErrors)
(
   CHMuntypedMessageTreeHandle Handle
);

#endif // end of defensive include
