#ifndef __IGC_CHARACTER_ENCODING_H__
#define __IGC_CHARACTER_ENCODING_H__
//--------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved.
//
// Class: IGCcharacterEncoding
//
// Description:
//
// Class interface definition.
//
// This file is automatically generated.
// DO NOT EDIT.
//
// Author: codegen2
// Date:   Wednesday, July 29th, 2009 @ 02:27:50 PM
// Revision: $Revision: 1.6 $
//
// Last Edit Date: $Date: 2009-08-31 13:17:48 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGCcharacterEncoding.h,v $
//--------------------------------------------------------------------------

#include <IGC/IGCminimumInclude.h>

/**
 *  This class is used to configure the IGC DLL character encoding for Windows C++ 
 * plugins. 
 * 
 *  Posix C++ plugins need not alter the default character encoding, since the only 
 * supported encoding on Posix platforms is UTF-8. 
 * 
 *  The IGC DLL character encoding is used to translate the strings passed between 
 * the plugin and IGC DLL to and from the strings passed between IGC DLL and 
 * Iguana. Strings passed between IGC DLL and Iguana are always encoded in UTF-8. 
 * Strings passed between the plugin and IGC DLL may be encoded in either UTF-8 or 
 * ANSI (on Windows only; the only encoding available on Posix is UTF-8). 
 * 
 *  For Windows C++ plugins, ANSI is the default character encoding. ANSI encoding 
 * means that the current Windows ANSI codepage is used for translation. In Win32 
 * terminology, the CP_ACP codepage is used. This means that on a Western system, 
 * the actual encoding used might be Windows-1252, whereas on a Taiwanese system it 
 * might be Big5. 
 * 
 *  Windows C++ plugins may switch the character encoding to UTF-8 in order to 
 * properly process messages with characters outside of the current Windows ANSI 
 * codepage. For example, this would allow a Western system using the Windows-1252 
 * codepage to process messages originally encoded in Chinese Big5. 
 * 
 *  The IGC DLL character encoding is intended to be adjusted only once per 
 * execution, before any plugin library classes are created, or plugin library 
 * functions are called. Plugin library classes use the character encoding setting 
 * in place at the time of their creation for the duration of their lifetime. Hence 
 * changing the character encoding affects only subsequently created instances, not 
 * existing instances. 
 * 
 */

class IGCcharacterEncoding
{
public:
  /**
    *  Sets the plugin library character encoding, either "ANSI" or "UTF-8". 
    * 
    *  See IGCcharacterEncoding for details. 
    * 
    */
   static void SetEncoding(const char* CharacterEncoding);
   
   
   /**
    *  Retrieves the plugin library character encoding, either "ANSI" or "UTF-8". 
    * 
    *  See IGCcharacterEncoding for details. 
    * 
    */
   static const char* GetEncoding();
   
private:
   /** Static class - construction not allowed */
   IGCcharacterEncoding();
   IGCcharacterEncoding(const IGCcharacterEncoding& Orig);
   IGCcharacterEncoding& operator=(const IGCcharacterEncoding& Orig);
   ~IGCcharacterEncoding();
};

#endif // end of defensive include
