#ifndef __IGC_DESTINATION_MESSAGE_RECEIVED_EVENT_OUTPUTS_H__
#define __IGC_DESTINATION_MESSAGE_RECEIVED_EVENT_OUTPUTS_H__
//--------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved.
//
// Class: IGCdestinationMessageReceivedEventOutputs
//
// Description:
//
// Class interface definition.
//
// This file is automatically generated.
// DO NOT EDIT.
//
// Author: codegen2
// Date:   Friday, September 11th, 2009 @ 02:14:06 PM
// Revision: $Revision: 1.1 $
//
// Last Edit Date: $Date: 2009-09-14 18:52:21 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGCdestinationMessageReceivedEventOutputs.h,v $
//--------------------------------------------------------------------------

#include <IGC/IGCminimumInclude.h>

#ifndef __IGC_DESTINATION_MESSAGE_RECEIVED_EVENT_OUTPUTS_HANDLE_H__
#define __IGC_DESTINATION_MESSAGE_RECEIVED_EVENT_OUTPUTS_HANDLE_H__
typedef void* IGCdestinationMessageReceivedEventOutputsHandle;
#endif


/**
 *  This class is used to send response data from IGCdestination#OnMessageReceived 
 * event handlers back to Iguana. 
 * 
 *  Destination plugins are provided with an instance of this class as an argument 
 * to their IGCdestination#OnMessageReceived event handler. The event handler uses 
 * the properties and methods of the provided instance to craft a suitable response 
 * to send back to Iguana. After the event handler returns, the response is sent 
 * back to Iguana. 
 * 
 *  At a minimum, the event handler should set the 
 * IGCdestinationMessageReceivedEventOutputs#MessageProcessedFlag property to true 
 * to indicate to Iguana that the message was received and processed by the plugin. 
 * Setting this property to false will simply result in Iguana logging a generic 
 * error message; it will not result in Iguana resending the message or stopping 
 * the channel. Plugins can achieve more sophisticated and precise error handling 
 * using the properties and methods described below. 
 * 
 *  If the event handler is unable to complete processing in a timely fashion, it 
 * should use the IGCdestinationMessageReceivedEventOutputs#ResendMessageFlag and 
 * IGCdestinationMessageReceivedEventOutputs#ResendMessageDelay properties to 
 * request that Iguana resend the message. This ensures that Iguana does not 
 * time-out the connection to the plugin due to inactivity. The exact duration of 
 * the time-out is determined by the Plugin Time field value configured for the To 
 * Plugin channel component to which the plugin is connected. 
 * 
 *  The plugin event handler may request that the Iguana channel be stopped via the 
 * IGCdestinationMessageReceivedEventOutputs#StopChannelFlag, 
 * IGCdestinationMessageReceivedEventOutputs#StopChannelErrorFlag and 
 * IGCdestinationMessageReceivedEventOutputs#StopChannelReason properties. 
 * 
 *  The plugin event handler may add log messages to Iguana's logs using the 
 * IGCdestinationMessageReceivedEventOutputs#AddErrorLogMessage, 
 * IGCdestinationMessageReceivedEventOutputs#AddWarningLogMessage, 
 * IGCdestinationMessageReceivedEventOutputs#AddInfoLogMessage and 
 * IGCdestinationMessageReceivedEventOutputs#AddDebugLogMessage methods. 
 * 
 */
class IGCdestinationMessageReceivedEventOutputs
{
public:
   /** Constructor */
   IGCdestinationMessageReceivedEventOutputs();
   IGCdestinationMessageReceivedEventOutputs(const IGCdestinationMessageReceivedEventOutputs& Orig);
   IGCdestinationMessageReceivedEventOutputs(IGCdestinationMessageReceivedEventOutputsHandle Handle);
   
   /** Destructor */
   virtual ~IGCdestinationMessageReceivedEventOutputs();
   
   /** Assignment operator */
   IGCdestinationMessageReceivedEventOutputs& operator=(const IGCdestinationMessageReceivedEventOutputs& Orig);
   
   /** This method is part of the internal implementation of this class and should not be called. */
   IGCdestinationMessageReceivedEventOutputsHandle GetHandle() const { return Handle; }
   
   
   /**
    *  Indicates to Iguana whether or not the message was processed by the plugin. 
    * 
    *  Default value: false. 
    * 
    *  Should generally be set by event handlers to true. 
    * 
    *  If set to false, Iguana will simply issue a relatively generic error message. 
    * Event handlers can add their own specific error log message to the Iguana logs 
    * using the IGCdestinationMessageReceivedEventOutputs#AddErrorLogMessage method 
    * instead. 
    * 
    * See also the IGCdestinationMessageReceivedEventOutputs#SetMessageProcessedFlag 
    * method.
    * 
    */
   IGCboolean MessageProcessedFlag() const;
   
   
   /**
    * Set method for MessageProcessedFlag.
    * 
    * See IGCdestinationMessageReceivedEventOutputs#MessageProcessedFlag.
    * 
    * @param Value Value to set MessageProcessedFlag to.
    */
   void SetMessageProcessedFlag(IGCboolean Value);
   
   
   /**
    *  Requests that Iguana resend the message. 
    * 
    *  Default value: false. 
    * 
    *  The message will be resent after the delay specified by 
    * IGCdestinationMessageReceivedEventOutputs#ResendMessageDelay. 
    * 
    *  If the channel is stopped, the message will be resent once the channel is 
    * restarted. 
    * 
    * See also the IGCdestinationMessageReceivedEventOutputs#SetResendMessageFlag 
    * method.
    * 
    */
   IGCboolean ResendMessageFlag() const;
   
   
   /**
    * Set method for ResendMessageFlag.
    * 
    * See IGCdestinationMessageReceivedEventOutputs#ResendMessageFlag.
    * 
    * @param Value Value to set ResendMessageFlag to.
    */
   void SetResendMessageFlag(IGCboolean Value);
   
   
   /**
    *  Specifies the delay time in milliseconds that Iguana should wait before 
    * resending the message. 
    * 
    *  Default value: 0 milliseconds. 
    * 
    *  Only applicable if IGCdestinationMessageReceivedEventOutputs#ResendMessageFlag 
    * is set to true. 
    * 
    * See also the IGCdestinationMessageReceivedEventOutputs#SetResendMessageDelay 
    * method.
    * 
    */
   IGCint32 ResendMessageDelay() const;
   
   
   /**
    * Set method for ResendMessageDelay.
    * 
    * See IGCdestinationMessageReceivedEventOutputs#ResendMessageDelay.
    * 
    * @param Value Value to set ResendMessageDelay to.
    */
   void SetResendMessageDelay(IGCint32 Value);
   
   
   /**
    *  Requests that Iguana stop the channel to which the plugin is connected. 
    * 
    *  Default value: false. 
    * 
    *  See also: IGCdestinationMessageReceivedEventOutputs#StopChannelErrorFlag and 
    * IGCdestinationMessageReceivedEventOutputs#StopChannelReason. 
    * 
    * See also the IGCdestinationMessageReceivedEventOutputs#SetStopChannelFlag 
    * method.
    * 
    */
   IGCboolean StopChannelFlag() const;
   
   
   /**
    * Set method for StopChannelFlag.
    * 
    * See IGCdestinationMessageReceivedEventOutputs#StopChannelFlag.
    * 
    * @param Value Value to set StopChannelFlag to.
    */
   void SetStopChannelFlag(IGCboolean Value);
   
   
   /**
    *  When combined with IGCdestinationMessageReceivedEventOutputs#StopChannelFlag, 
    * requests that Iguana stop the channel with the channel status set to 'error'. 
    * 
    *  Default value: false. 
    * 
    *  Only applicable if IGCdestinationMessageReceivedEventOutputs#StopChannelFlag is 
    * set to true. 
    * 
    * See also the IGCdestinationMessageReceivedEventOutputs#SetStopChannelErrorFlag 
    * method.
    * 
    */
   IGCboolean StopChannelErrorFlag() const;
   
   
   /**
    * Set method for StopChannelErrorFlag.
    * 
    * See IGCdestinationMessageReceivedEventOutputs#StopChannelErrorFlag.
    * 
    * @param Value Value to set StopChannelErrorFlag to.
    */
   void SetStopChannelErrorFlag(IGCboolean Value);
   
   
   /**
    *  Describes the reason for the 'stop channel' request. 
    * 
    *  Only applicable if IGCdestinationMessageReceivedEventOutputs#StopChannelFlag is 
    * set to true. 
    * 
    * See also the IGCdestinationMessageReceivedEventOutputs#SetStopChannelReason 
    * method.
    * 
    */
   const char* StopChannelReason() const;
   
   
   /**
    * Set method for StopChannelReason.
    * 
    * See IGCdestinationMessageReceivedEventOutputs#StopChannelReason.
    * 
    * @param Value Value to set StopChannelReason to.
    */
   void SetStopChannelReason(const char* Value);
   
   
   /**
    *  Adds an error log message to Iguana's logs. 
    * 
    * @param ErrorLogMessage Log message text.
    */
   void AddErrorLogMessage(const char* ErrorLogMessage);
   
   
   /**
    *  Adds a warning log message to Iguana's logs. 
    * 
    * @param WarningLogMessage Log message text.
    */
   void AddWarningLogMessage(const char* WarningLogMessage);
   
   
   /**
    *  Adds an info log message to Iguana's logs. 
    * 
    * @param InfoLogMessage Log message text.
    */
   void AddInfoLogMessage(const char* InfoLogMessage);
   
   
   /**
    *  Adds a debug log message to Iguana's logs. 
    * 
    * @param DebugLogMessage Log message text.
    */
   void AddDebugLogMessage(const char* DebugLogMessage);
   
   
private:
   IGCdestinationMessageReceivedEventOutputsHandle Handle;
};

#endif // end of defensive include
