#ifndef __IGC_DISCONNECT_REASON_H__
#define __IGC_DISCONNECT_REASON_H__
//--------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved.
//
// Class: IGCdisconnectReason
//
// Description:
//
// Class interface definition.
//
// This file is automatically generated.
// DO NOT EDIT.
//
// Author: codegen2
// Date:   Thursday, May 28th, 2009 @ 10:15:00 AM
// Revision: $Revision: 1.5 $
//
// Last Edit Date: $Date: 2009-08-12 15:48:37 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGCdisconnectReason.h,v $
//--------------------------------------------------------------------------

#include <IGC/IGCminimumInclude.h>

#ifndef __IGC_DISCONNECT_REASON_HANDLE_H__
#define __IGC_DISCONNECT_REASON_HANDLE_H__
typedef void* IGCdisconnectReasonHandle;
#endif


/**
 *  This class is used to describe the reason for a plugin's disconnection from 
 * Iguana. 
 * 
 *  The IGCdisconnectReason for a plugin's most recent disconnection from Iguana 
 * may be retrieved from the IGCsource#DisconnectReason or 
 * IGCdestination#DisconnectReason properties, depending on the type of the plugin.
 *  
 * 
 *  The disconnect reason includes three mutually exclusive flags indicating the 
 * reason for the disconnection: IGCdisconnectReason#DueToIguana, 
 * IGCdisconnectReason#DueToPlugin, and IGCdisconnectReason#DueToError. These flags 
 * can be used programmatically to customize plugin disconnection handling 
 * depending on the cause of the disconnection. 
 * 
 *  The disconnect reason includes a textual description of the reason for 
 * disconnection: IGCdisconnectReason#Description. The textual description may 
 * contain additional details useful in diagnosing unexpected disconnections, 
 * especially in the case of disconnection due to errors. 
 * 
 */
class IGCdisconnectReason
{
public:
   /** Constructor */
   IGCdisconnectReason();
   IGCdisconnectReason(const IGCdisconnectReason& Orig);
   IGCdisconnectReason(IGCdisconnectReasonHandle Handle);
   
   /** Destructor */
   virtual ~IGCdisconnectReason();
   
   /** Assignment operator */
   IGCdisconnectReason& operator=(const IGCdisconnectReason& Orig);
   
   /** This method is part of the internal implementation of this class and should not be called. */
   IGCdisconnectReasonHandle GetHandle() const { return Handle; }
   
   
   /**
    *  Indicates that Iguana closed the connection with the plugin. 
    * 
    *  Iguana closes its connection with a plugin when stopping the plugin channel. 
    * 
    */
   IGCboolean DueToIguana() const;
   
   
   /**
    *  Indicates that the plugin requested disconnection from Iguana. 
    * 
    *  Plugins may request disconnection by invoking the IGCsource#Disconnect or 
    * IGCdestination#Disconnect methods, depending on the type of plugin. 
    * 
    */
   IGCboolean DueToPlugin() const;
   
   
   /**
    *  Indicates that the connection between Iguana and the plugin was closed due to 
    * an error. 
    * 
    *  A textual description of the error is available via the 
    * IGCdisconnectReason#Description property. 
    * 
    */
   IGCboolean DueToError() const;
   
   
   /**
    *  Provides a textual description of the reason for disconnection. 
    * 
    */
   const char* Description() const;
   
   
private:
   IGCdisconnectReasonHandle Handle;
};

#endif // end of defensive include
