//---------------------------------------------------------------------------
//
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved
//
// Module: IGCexceptionDll
//
// Description:
//
// Implementation Interface.
//
// Revision: $Revision: 1.4 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGCerrorClass.cpp,v $
// Author: Code Generator
// Last Edit Date: $Date: 2009-08-18 20:57:17 $
//
//---------------------------------------------------------------------------
#include "IGCpreCompHead.h"
#pragma hdrstop

#include <IGC/IGCerrorClass.h>
#include <IGC/IGCexceptionDll.h>

#include <string.h> // strdup

#ifdef __BORLANDC__
#  define IGCstrdup strdup
#elif defined WIN32
#  define IGCstrdup _strdup
#else
#  define IGCstrdup strdup
#endif

IGCerror::IGCerror(const char* Description_, IGCint LineNumber_, const char* FileName_)
:
   _Description(IGCstrdup(Description_)),
   _LineNumber(LineNumber_),
   _FileName(IGCstrdup(FileName_))
{
}

IGCerror::IGCerror(IGCexceptionHandle Handle, IGCint LineNumber_, const char* FileName_)
:
   _Description(0),
   _LineNumber(LineNumber_),
   _FileName(IGCstrdup(FileName_))
{
   IGC_CHECK_CALL(IGCexceptionAddRef(Handle));

   try
   {
      const char* Description_ = 0;
      IGC_CHECK_CALL(IGCexceptionGetDescription(Handle, &Description_));
      _Description = IGCstrdup(Description_);
   }
   catch(...)
   {
   }

   IGC_CHECK_CALL(IGCexceptionRelease(Handle));
}

IGCerror::IGCerror(const IGCerror& Orig)
:
   _Description(IGCstrdup(Orig._Description)),
   _LineNumber(Orig._LineNumber),
   _FileName(IGCstrdup(Orig._FileName))
{
}

IGCerror& IGCerror::operator=(const IGCerror& Orig)
{
   if (this != &Orig)
   {
      _Description = IGCstrdup(Orig._Description);
      _LineNumber = Orig._LineNumber;
      _FileName = IGCstrdup(Orig._FileName);
   }

   return *this;
}

IGCerror::~IGCerror()
{
   if (_Description)
   {
      free(_Description);
      _Description = 0;
   }

   if (_FileName)
   {
      free(_FileName);
      _FileName = 0;
   }
}
