#ifndef __IGC_ERROR_CLASS_H__
#define __IGC_ERROR_CLASS_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved
//
// Module: IGCerrorClass
//
// Description:
//
// IGC error exception.
//
// Revision: $Revision: 1.2 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGCerrorClass.h,v $
// Author: Code Generator
// Last Edit Date: $Date: 2009-04-09 19:47:40 $
//---------------------------------------------------------------------------
#include <IGC/IGCminimumInclude.h>

#ifndef __IGC_EXCEPTION_HANDLE_H__
#define __IGC_EXCEPTION_HANDLE_H__
typedef void* IGCexceptionStubHandle;
typedef void* IGCexceptionHandle;
#endif

class IGCerror
{
public:
   /** Constructor */
   IGCerror(const char* Description, IGCint LineNumber, const char* FileName);
   IGCerror(IGCexceptionHandle Handle, IGCint LineNumber, const char* FileName);
   IGCerror(const IGCerror& Orig);
   
   /** Destructor */
   virtual ~IGCerror();
   
   /** Assignment operator */
   IGCerror& operator=(const IGCerror& Orig);
   
   const char* Description() const
   {
      return _Description;
   }

   IGCint LineNumber() const
   {
      return _LineNumber;
   }

   const char* FileName() const
   {
      return _FileName;
   }

private:
   char* _Description;
   IGCint _LineNumber;
   char* _FileName;
};

#define IGC_CHECK_CALL(x)\
{\
   IGCresult Result = IGC_DLL_CALL(x);\
   if (Result != IGC_OK)\
   {\
      throw IGCerror(Result, __LINE__, __FILE__);\
   }\
}

#define IGC_ASSERT(x)\
if (!(x))\
{\
   throw IGCerror(IGC_TEXT(#x), __LINE__, __FILE__);\
}

#endif // end of defensive include
