#ifndef __IGC_LOG_MESSAGE_H__
#define __IGC_LOG_MESSAGE_H__
//--------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved.
//
// Class: IGClogMessage
//
// Description:
//
// Class interface definition.
//
// This file is automatically generated.
// DO NOT EDIT.
//
// Author: codegen2
// Date:   Thursday, October 15th, 2009 @ 04:04:10 PM
// Revision: $Revision: 1.3.2.1 $
//
// Last Edit Date: $Date: 2009-12-08 17:41:37 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGClogMessage.h,v $
//--------------------------------------------------------------------------

#include <time.h>
#include <IGC/IGCminimumInclude.h>

#ifndef __IGC_LOG_MESSAGE_HANDLE_H__
#define __IGC_LOG_MESSAGE_HANDLE_H__
typedef void* IGClogMessageHandle;
#endif


/**
 *  This class is used to represent an individual Iguana log message. 
 * 
 */
class IGClogMessage
{
public:
   /** Constructor */
   IGClogMessage();
   IGClogMessage(const IGClogMessage& Orig);
   IGClogMessage(IGClogMessageHandle Handle);
   
   /** Destructor */
   virtual ~IGClogMessage();
   
   /** Assignment operator */
   IGClogMessage& operator=(const IGClogMessage& Orig);
   
   /** This method is part of the internal implementation of this class and should not be called. */
   IGClogMessageHandle GetHandle() const { return Handle; }
   
   
   /**
    *  Provides the name of the source channel associated with the message, or an 
    * empty string if the message is not associated with a specific channel. 
    * 
    */
   const char* ChannelName() const;
   
   
   /**
    *  Provides the type of this message 
    * (Message/Ack/Success/Warning/Error/Info/Debug) 
    * 
    */
   const char* MessageType() const;
   
   
   /**
    *  Provides the full body of the message. 
    * 
    */
   const char* Content() const;
   
   
   /**
    *  Provides the ID that is used to uniquely identify this message. This ID can be 
    * used to query related messages. 
    * 
    */
   const char* MessageLogId() const;
   
   
   /**
    *  Provides the ID of the parent of this message. It will be empty if there is no 
    * parent. 
    * 
    */
   const char* ReferenceLogId() const;
   
   
   /**
    *  Provides a timestamp of the message with second precision. Milliseconds are 
    * available via the IGClogMessage#Milliseconds property. 
    * 
    */
   time_t TimeStamp() const;
   
   
   /**
    *  Provides the number of milliseconds (0-999) associated with the 
    * IGClogMessage#TimeStamp property. 
    * 
    */
   IGCint32 Milliseconds() const;
   
   
   /**
    *  This flag is set if the message has been deleted through Iguana dashboard by an 
    * administrator. 
    * 
    */
   IGCboolean Deleted() const;
   
   
   /**
    *  This flag is set if this error has been marked (acknowledged) through Iguana 
    * dashboard by an administrator. (Only applicable to message type Error) 
    * 
    */
   IGCboolean MarkedError() const;
   
   
   /**
    *  This flag is set if this message is the original of a separate resubmitted 
    * message. (Only applicable to message Type Message) 
    * 
    */
   IGCboolean Resubmitted() const;
   
   
   /**
    *  This flag is set if this message is a re-submission an earlier message. (Only 
    * applicable to message Type Message) 
    * 
    */
   IGCboolean IsResubmission() const;
   
   
private:
   IGClogMessageHandle Handle;
};

#endif // end of defensive include
