#ifndef __IGC_LOG_QUERY_RESULT_H__
#define __IGC_LOG_QUERY_RESULT_H__
//--------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved.
//
// Class: IGClogQueryResult
//
// Description:
//
// Class interface definition.
//
// This file is automatically generated.
// DO NOT EDIT.
//
// Author: codegen2
// Date:   Thursday, October 15th, 2009 @ 04:04:10 PM
// Revision: $Revision: 1.3 $
//
// Last Edit Date: $Date: 2009-10-20 21:20:25 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGClogQueryResult.h,v $
//--------------------------------------------------------------------------

#include <IGC/IGCminimumInclude.h>
// Predeclared Classes
class IGClogMessage;


#ifndef __IGC_LOG_QUERY_RESULT_HANDLE_H__
#define __IGC_LOG_QUERY_RESULT_HANDLE_H__
typedef void* IGClogQueryResultHandle;
#endif


/**
 *  This class is used to describe the result of IGClogQuery#Execute. 
 * 
 */
class IGClogQueryResult
{
public:
   /** Constructor */
   IGClogQueryResult();
   IGClogQueryResult(const IGClogQueryResult& Orig);
   IGClogQueryResult(IGClogQueryResultHandle Handle);
   
   /** Destructor */
   virtual ~IGClogQueryResult();
   
   /** Assignment operator */
   IGClogQueryResult& operator=(const IGClogQueryResult& Orig);
   
   /** This method is part of the internal implementation of this class and should not be called. */
   IGClogQueryResultHandle GetHandle() const { return Handle; }
   
   
   /**
    *  Indicates that the query was executed successfully. 
    * 
    */
   IGCboolean Success() const;
   
   
   /**
    *  Provides a textual description of the error which occured if 
    * IGClogQueryResult#Success is false. 
    * 
    */
   const char* ErrorDescription() const;
   
   
   /**
    *  Provides an array of IGClogMessage which were returned by Iguana in response to 
    * the query. 
    * 
    * @param MessageIndex The index of the Message to return.
    */
   IGClogMessage Message(IGCint32 MessageIndex) const;
   
   
   /**
    * Returns the total number of Messages.
    * 
    * See also the IGClogQueryResult#Message property.
    * 
    */
   IGCint32 CountOfMessage() const;
   
   
private:
   IGClogQueryResultHandle Handle;
};

#endif // end of defensive include
