#ifndef __IGC_MINIMUM_INCLUDE_H__
#define __IGC_MINIMUM_INCLUDE_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved
//
// Module: IGCminimumInclude 
//
// Description:
//
// DLL Interface.
//
// Revision: $Revision: 1.10 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGCminimumInclude.h,v $
// Author: Code Generator
// Last Edit Date: $Date: 2009-08-18 20:57:17 $
//---------------------------------------------------------------------------

#ifdef CHM_NO_BOOLEAN_TYPE
   #define IGCboolean int
   #define true 1
   #define false 0
#elif defined(__cplusplus)
   #define IGCboolean bool
#else
   #define IGCboolean int
#endif

#define IGCint int
#define IGCuint unsigned int
#define IGCint32 int
#define IGCuint32 unsigned IGCint32

typedef void* IGCresult;
#define IGC_OK 0
#define IGC_UNKNOWN_EXCEPTION -1

#define IGClogMessageType IGCuint
#define IGC_LOG_MESSAGE_NIL     0  // Default value - not a valid log message type
#define IGC_LOG_MESSAGE_ERROR   1  // Error-level log message
#define IGC_LOG_MESSAGE_INFO    2  // Info-level log message
#define IGC_LOG_MESSAGE_DEBUG   3  // Debug-level log message
#define IGC_LOG_MESSAGE_WARNING 4  // Warning-level log message

// Disables buffering of the stdout and stderr output streams so that command-line
// output is displayed immediately, rather than when the output buffer happens to be
// filled.  Very useful for debugging, especially when using Iguana's Monitor Executable
// Output feature.
//
// Must be invoked before any output is written to stdout or stderr in order to take effect.
// Probably best to invoke at the beginning of the plugin's main() method.
//
// Requires #include <stdio.h>.
#define IGC_DISABLE_OUTPUT_BUFFERING() \
{\
   setvbuf(stdout, NULL, _IONBF, 0);\
   setvbuf(stderr, NULL, _IONBF, 0);\
}

#define IGC_TEXT(x) #x

#ifdef __cplusplus
#   define IGC_EXTERN_C extern "C"
#else
#   define IGC_EXTERN_C extern
#endif

#ifdef WIN32
#   define IGC_STD_CALL __stdcall
#else
#   define IGC_STD_CALL
#endif

#ifdef IGC_DLL_EXPORTS
#   ifdef WIN32
#      ifdef __BORLANDC__
#         define IGC_DLL_FUNC(Y) IGC_EXTERN_C IGCresult _export Y
#         define IGC_DLL_CALL(Y) Y 
#      else
#         define IGC_DLL_FUNC(Y) IGC_EXTERN_C __declspec(dllexport) IGCresult __stdcall Y
#         define IGC_DLL_CALL(Y) Y 
#      endif
#   else
#      define IGC_DLL_FUNC(Y) IGC_EXTERN_C IGCresult Y
#      define IGC_DLL_CALL(Y) Y
#   endif
#else 
#   ifdef WIN32
#      ifdef __BORLANDC__
#         define IGC_DLL_FUNC(Y) IGC_EXTERN_C IGCresult _import __stdcall _##Y
#         define IGC_DLL_CALL(Y) _##Y
#      elif defined(CHM_64)
#         define IGC_DLL_FUNC(Y) IGC_EXTERN_C __declspec(dllimport) IGCresult __stdcall Y
#         define IGC_DLL_CALL(Y) Y 
#      else
#         define IGC_DLL_FUNC(Y) IGC_EXTERN_C __declspec(dllimport) IGCresult __stdcall _##Y
#         define IGC_DLL_CALL(Y) _##Y 
#      endif
#   else
#      define IGC_DLL_FUNC(Y) IGC_EXTERN_C IGCresult Y
#      define IGC_DLL_CALL(Y) Y
#   endif
#endif

#endif // end of defensive include
