#ifndef __IGC_SOURCE_MESSAGE_REQUESTED_EVENT_OUTPUTS_H__
#define __IGC_SOURCE_MESSAGE_REQUESTED_EVENT_OUTPUTS_H__
//--------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc. All Rights Reserved.
//
// Class: IGCsourceMessageRequestedEventOutputs
//
// Description:
//
// Class interface definition.
//
// This file is automatically generated.
// DO NOT EDIT.
//
// Author: codegen2
// Date:   Friday, September 11th, 2009 @ 02:14:06 PM
// Revision: $Revision: 1.1 $
//
// Last Edit Date: $Date: 2009-09-14 18:52:21 $
// Source: $Source: /home/cvs/cvsroot/IGC/IGCsourceMessageRequestedEventOutputs.h,v $
//--------------------------------------------------------------------------

#include <IGC/IGCminimumInclude.h>

#ifndef __IGC_SOURCE_MESSAGE_REQUESTED_EVENT_OUTPUTS_HANDLE_H__
#define __IGC_SOURCE_MESSAGE_REQUESTED_EVENT_OUTPUTS_HANDLE_H__
typedef void* IGCsourceMessageRequestedEventOutputsHandle;
#endif


/**
 *  This class is used to send response data from IGCsource#OnMessageRequested 
 * event handlers back to Iguana. 
 * 
 *  Source plugins are provided with an instance of this class as an argument to 
 * their IGCsource#OnMessageRequested event handler. The event handler uses the 
 * properties and methods of the provided instance to craft a suitable response to 
 * send back to Iguana. After the event handler returns, the response is sent back 
 * to Iguana. 
 * 
 *  At a minimum, the event handler should set the 
 * IGCsourceMessageRequestedEventOutputs#OutboundMessage and 
 * IGCsourceMessageRequestedEventOutputs#PluginMessageId properties to appropriate 
 * values. 
 * 
 *  The plugin event handler may request that the Iguana channel be stopped via the 
 * IGCsourceMessageRequestedEventOutputs#StopChannelFlag, 
 * IGCsourceMessageRequestedEventOutputs#StopChannelErrorFlag and 
 * IGCsourceMessageRequestedEventOutputs#StopChannelReason properties. 
 * 
 *  The plugin event handler may add log messages to Iguana's logs using the 
 * IGCsourceMessageRequestedEventOutputs#AddErrorLogMessage, 
 * IGCsourceMessageRequestedEventOutputs#AddWarningLogMessage, 
 * IGCsourceMessageRequestedEventOutputs#AddInfoLogMessage and 
 * IGCsourceMessageRequestedEventOutputs#AddDebugLogMessage methods. 
 * 
 */
class IGCsourceMessageRequestedEventOutputs
{
public:
   /** Constructor */
   IGCsourceMessageRequestedEventOutputs();
   IGCsourceMessageRequestedEventOutputs(const IGCsourceMessageRequestedEventOutputs& Orig);
   IGCsourceMessageRequestedEventOutputs(IGCsourceMessageRequestedEventOutputsHandle Handle);
   
   /** Destructor */
   virtual ~IGCsourceMessageRequestedEventOutputs();
   
   /** Assignment operator */
   IGCsourceMessageRequestedEventOutputs& operator=(const IGCsourceMessageRequestedEventOutputs& Orig);
   
   /** This method is part of the internal implementation of this class and should not be called. */
   IGCsourceMessageRequestedEventOutputsHandle GetHandle() const { return Handle; }
   
   
   /**
    *  Message to send back to Iguana, or an empty string if a message is not 
    * presently available. 
    * 
    * See also the IGCsourceMessageRequestedEventOutputs#SetOutboundMessage method.
    * 
    */
   const char* OutboundMessage() const;
   
   
   /**
    * Set method for OutboundMessage.
    * 
    * See IGCsourceMessageRequestedEventOutputs#OutboundMessage.
    * 
    * @param Value Value to set OutboundMessage to.
    */
   void SetOutboundMessage(const char* Value);
   
   
   /**
    *  Id to be assigned by the plugin to uniquely identify 
    * IGCsourceMessageRequestedEventOutputs#OutboundMessage. 
    * 
    *  Iguana sends the provided PluginMessageId back to the plugin's 
    * IGCsource#OnMessageRequestCompleted event handler via 
    * IGCsourceMessageRequestCompletedEventInputs#PluginMessageId property. This 
    * allows the plugin to associate each message request completed notification with 
    * the message sent to Iguana. 
    * 
    *  The format of the PluginMessageId is to be determined by the plugin author. 
    * Iguana does not interpret this value, other than by adding it to logs, and 
    * sending it back to the plugin. 
    * 
    * See also the IGCsourceMessageRequestedEventOutputs#SetPluginMessageId method.
    * 
    */
   const char* PluginMessageId() const;
   
   
   /**
    * Set method for PluginMessageId.
    * 
    * See IGCsourceMessageRequestedEventOutputs#PluginMessageId.
    * 
    * @param Value Value to set PluginMessageId to.
    */
   void SetPluginMessageId(const char* Value);
   
   
   /**
    *  Requests that Iguana stop the channel to which the plugin is connected. 
    * 
    *  Default value: false. 
    * 
    *  See also: IGCsourceMessageRequestedEventOutputs#StopChannelErrorFlag and 
    * IGCsourceMessageRequestedEventOutputs#StopChannelReason. 
    * 
    * See also the IGCsourceMessageRequestedEventOutputs#SetStopChannelFlag method.
    * 
    */
   IGCboolean StopChannelFlag() const;
   
   
   /**
    * Set method for StopChannelFlag.
    * 
    * See IGCsourceMessageRequestedEventOutputs#StopChannelFlag.
    * 
    * @param Value Value to set StopChannelFlag to.
    */
   void SetStopChannelFlag(IGCboolean Value);
   
   
   /**
    *  When combined with IGCsourceMessageRequestedEventOutputs#StopChannelFlag, 
    * requests that Iguana stop the channel with the channel status set to 'error'. 
    * 
    *  Default value: false. 
    * 
    *  Only applicable if IGCsourceMessageRequestedEventOutputs#StopChannelFlag is set 
    * to true. 
    * 
    * See also the IGCsourceMessageRequestedEventOutputs#SetStopChannelErrorFlag 
    * method.
    * 
    */
   IGCboolean StopChannelErrorFlag() const;
   
   
   /**
    * Set method for StopChannelErrorFlag.
    * 
    * See IGCsourceMessageRequestedEventOutputs#StopChannelErrorFlag.
    * 
    * @param Value Value to set StopChannelErrorFlag to.
    */
   void SetStopChannelErrorFlag(IGCboolean Value);
   
   
   /**
    *  Describes the reason for the 'stop channel' request. 
    * 
    *  Only applicable if IGCsourceMessageRequestedEventOutputs#StopChannelFlag is set 
    * to true. 
    * 
    * See also the IGCsourceMessageRequestedEventOutputs#SetStopChannelReason method.
    * 
    */
   const char* StopChannelReason() const;
   
   
   /**
    * Set method for StopChannelReason.
    * 
    * See IGCsourceMessageRequestedEventOutputs#StopChannelReason.
    * 
    * @param Value Value to set StopChannelReason to.
    */
   void SetStopChannelReason(const char* Value);
   
   
   /**
    *  Adds an error log message to Iguana's logs. 
    * 
    * @param ErrorLogMessage Log message text.
    */
   void AddErrorLogMessage(const char* ErrorLogMessage);
   
   
   /**
    *  Adds a warning log message to Iguana's logs. 
    * 
    * @param WarningLogMessage Log message text.
    */
   void AddWarningLogMessage(const char* WarningLogMessage);
   
   
   /**
    *  Adds an info log message to Iguana's logs. 
    * 
    * @param InfoLogMessage Log message text.
    */
   void AddInfoLogMessage(const char* InfoLogMessage);
   
   
   /**
    *  Adds a debug log message to Iguana's logs. 
    * 
    * @param DebugLogMessage Log message text.
    */
   void AddDebugLogMessage(const char* DebugLogMessage);
   
   
private:
   IGCsourceMessageRequestedEventOutputsHandle Handle;
};

#endif // end of defensive include
