#----------------------------------------------------------------------------
# Copyright (C) 1997-2008 iNTERFACEWARE Inc.  All Rights Reserved
#
# Module: ifware.iguana
#
# Description:
#
# Facilitates interaction with Iguana.
#
# Revision: $Revision: 1.3 $
#----------------------------------------------------------------------------

# vim: sts=3 ts=3 sw=3 et

__all__ = [
   'message',
]

import _ifware_iguana

def _api(query, arg=None):
   try:
      response = _ifware_iguana.query(query, arg)
      if response is None:
         error = _ifware_iguana.query('last_error', None)
         raise RuntimeError, error
      else:
         return response
   except NotImplementedError:
      raise NotImplementedError, 'Not connected to Iguana.'

class Message:
   def __getattr__(self, attr):
      try:
         return _api('message', attr)
      except NotImplementedError:
         if attr == 'log_id':
            return '[MessageLogID]'
         else:
            raise

message = Message()
